=== debian/changelog ===
dmlc-core (0.0~git20200912.bfad207-3) unstable; urgency=medium

  * Stop tracking the C++ symbols.

 -- Mo Zhou <lumin@debian.org>  Mon, 26 Oct 2020 20:17:53 +0800

dmlc-core (0.0~git20200912.bfad207-2) unstable; urgency=medium

  * Patch: rollback to upstream snapshot version 5df8305.
  * Refresh symbols control file.

 -- Mo Zhou <lumin@debian.org>  Mon, 21 Sep 2020 12:12:53 +0800

dmlc-core (0.0~git20200912.bfad207-1) unstable; urgency=medium

  * New upstream version 0.0~git20200912.bfad207
  * Fixup hardening problem caused by typo.
  * Add symbols control file.

 -- Mo Zhou <lumin@debian.org>  Sun, 20 Sep 2020 15:04:05 +0800

dmlc-core (0.0~git20200410.5df8305-2) unstable; urgency=medium

  * Change maintainer address into debian-ai@l.d.o
  * Apply wrap-and-sort.
  * Bump debhelper compat level to 13.
  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Thu, 17 Sep 2020 10:21:17 +0800

dmlc-core (0.0~git20200410.5df8305-1) experimental; urgency=medium

  * Initial release. (Closes: #958294)

 -- Mo Zhou <lumin@debian.org>  Mon, 20 Apr 2020 17:35:30 +0800
