=== debian/control ===
Source: dmlc-core
Section: science
Homepage: https://github.com/dmlc/dmlc-core/
Priority: optional
Standards-Version: 4.5.0
Vcs-Git: https://salsa.debian.org/deeplearning-team/dmlc-core.git
Vcs-Browser: https://salsa.debian.org/deeplearning-team/dmlc-core
Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>
Build-Depends: cmake, debhelper-compat (= 13), libssl-dev
Rules-Requires-Root: no

Package: libdmlc-dev
Section: libdevel
Architecture: any
Depends: libdmlc0 (= ${binary:Version}), ${misc:Depends}
Description: Distributed Machine Learning Common Codebase (dev)
 DMLC-Core is the backbone library to support all DMLC projects, offers the
 bricks to build efficient and scalable distributed machine learning libraries.
 .
 This package contains the development files.

Package: libdmlc0
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Distributed Machine Learning Common Codebase (dev)
 DMLC-Core is the backbone library to support all DMLC projects, offers the
 bricks to build efficient and scalable distributed machine learning libraries.
 .
 This package contains the shared objects.
