=== debian/watch ===
version=4
opts="mode=git, pgpmode=none" \
https://github.com/dmlc/dmlc-core \
HEAD debian uupdate
