=== debian/changelog ===
dmlc-core (0.5-1) unstable; urgency=medium

  * New upstream version 0.5 (Git: f00e3ec)
    - This version is used by xgboost 1.5.1.
  * d/watch: Track git tags instead of git HEAD.
  * Remove patch: fall-back-to-5df8305.patch
  * Refresh remaining patches.
  * Minor fix to short Descriptions.

 -- Mo Zhou <lumin@debian.org>  Mon, 03 Jan 2022 12:56:18 -0500
