=== debian/control ===
--- 
+++ 
@@ -24,7 +24,7 @@
 Section: libs
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
-Description: Distributed Machine Learning Common Codebase (dev)
+Description: Distributed Machine Learning Common Codebase (lib)
  DMLC-Core is the backbone library to support all DMLC projects, offers the
  bricks to build efficient and scalable distributed machine learning libraries.
  .
