## dmlc-core 0.5+git20240614.1334185

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.2)
+cmake_minimum_required(VERSION 3.15 FATAL_ERROR)
 
 project(dmlc VERSION 0.3 LANGUAGES C CXX)
 
@@ -17,6 +17,7 @@
 dmlccore_option(DMLC_HDFS_SHARED "Build with dynamic HDFS library" OFF)
 dmlccore_option(USE_AZURE "Build with AZURE support" OFF)
 dmlccore_option(USE_S3 "Build with S3 support" OFF)
+dmlccore_option(USE_PARQUET "Build with Arrow Parquet" OFF)
 dmlccore_option(USE_OPENMP "Build with OpenMP" ON)
 dmlccore_option(USE_CXX14_IF_AVAILABLE "Build with C++14 if the compiler supports it" OFF)
 dmlccore_option(GOOGLE_TEST "Build google tests" OFF)
@@ -58,6 +59,10 @@
 endif()
 
 add_library(dmlc ${SOURCE})
+set_target_properties(dmlc PROPERTIES
+  VERSION ${PROJECT_VERSION}
+  SOVERSION ${PROJECT_VERSION_MAJOR})
+target_compile_features(dmlc PUBLIC cxx_std_${CMAKE_CXX_STANDARD})
 
 # Sanitizer
 if (DMLC_USE_SANITIZER)
@@ -67,6 +72,21 @@
   enable_sanitizers("${DMLC_ENABLED_SANITIZERS}")
 endif (DMLC_USE_SANITIZER)
 
+if(USE_PARQUET)
+  find_package(Arrow REQUIRED)
+  find_package(Parquet REQUIRED)
+  if(BUILD_SHARED_LIBS)
+    target_link_libraries(dmlc PRIVATE arrow_shared parquet_shared)
+  else()
+    # No need to use arrow_static / parquet_static here, since
+    # we don't have a compelling need to include Arrow and Parquet
+    # in the generaed static lib libdmlc.a. This is similar to
+    # how we don't statically link with OpenSSL and cURL.
+    target_link_libraries(dmlc PUBLIC arrow_shared parquet_shared)
+  endif()
+  set(DMLC_USE_PARQUET 1)
+endif()
+
 # HDFS configurations
 if(USE_HDFS)
   find_package(HDFS REQUIRED)
@@ -110,21 +130,11 @@
   endif()
 
   find_package(OpenMP REQUIRED)
-
-  # For CMake < 3.9, we need to make target OpenMP::OpenMP_CXX ourselves
-  if(NOT TARGET OpenMP::OpenMP_CXX)
-    find_package(Threads REQUIRED)
-    add_library(OpenMP::OpenMP_CXX IMPORTED INTERFACE)
-    set_property(TARGET OpenMP::OpenMP_CXX
-                 PROPERTY INTERFACE_COMPILE_OPTIONS ${OpenMP_CXX_FLAGS})
-    set_property(TARGET OpenMP::OpenMP_CXX
-                 PROPERTY INTERFACE_LINK_LIBRARIES ${OpenMP_CXX_FLAGS} Threads::Threads)
-  endif()
   target_link_libraries(dmlc PRIVATE OpenMP::OpenMP_CXX)
 endif()
 
 if(WIN32 AND (NOT MSVC))  # On Windows, link Shlwapi.lib for non-MSVC compilers
-  target_link_libraries(dmlc PRIVATE Shlwapi)
+  target_link_libraries(dmlc PRIVATE shlwapi)
 endif()
 
 # Check location of clock_gettime; if it's in librt, link it
@@ -179,14 +189,12 @@
 # compiler flags
 if(MSVC)
   target_compile_definitions(dmlc PUBLIC -DDMLC_USE_CXX11=1)
-  if(NOT BUILD_SHARED_LIBS AND NOT DMLC_FORCE_SHARED_CRT)
-    foreach(flag_var
-          CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
-          CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
-      if(${flag_var} MATCHES "/MD")
-        string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
-      endif(${flag_var} MATCHES "/MD")
-    endforeach(flag_var)
+  if(DMLC_FORCE_SHARED_CRT)
+    message(STATUS "DMLC-Core: Using dynamically linked MSVC runtime...")
+    set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>DLL")
+  else()
+    message(STATUS "DMLC-Core: Using statically linked MSVC runtime...")
+    set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
   endif()
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /EHsc")
 else()
