=== debian/changelog ===
dmlc-core (0.5+git20240614.1334185-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Apply multi-arch hints. + libdmlc0: Add Multi-Arch: same.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * Update standards version to 4.6.1, no changes needed.

  [ Mo Zhou ]
  * New upstream version 0.5+git20240614.1334185
  * Update watch file to track Git HEAD.
  * Rebase existing patches.

 -- Mo Zhou <lumin@debian.org>  Thu, 18 Jul 2024 01:24:11 -0400

dmlc-core (0.5-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062377

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Wed, 28 Feb 2024 01:54:27 +0000
